"use strict";

Object.defineProperty(exports, "__esModule", {
	value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _CreateServiceContextGenerator = require("./CreateServiceContextGenerator");

var _CreateServiceContextGenerator2 = _interopRequireDefault(_CreateServiceContextGenerator);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

exports.default = function (_ref) {
	var domainServices = _ref.domainServices;

	var domainContexts = {};

	Object.keys(domainServices).forEach(function (domainServiceName) {
		domainContexts[domainServiceName] = (0, _CreateServiceContextGenerator2.default)({
			domainService: domainServices[domainServiceName].type
		});
	});

	return function (config) {
		var context = {};

		Object.keys(domainContexts).forEach(function (domainServiceName) {
			context[domainServiceName] = domainContexts[domainServiceName](_extends({}, config[domainServiceName], {
				token: config.token
			}));
		});

		return context;
	};
};