"use strict";

Object.defineProperty(exports, "__esModule", {
	value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _graphql = require("graphql");

var _CreateContextGenerator = require("./CreateContextGenerator");

var _CreateContextGenerator2 = _interopRequireDefault(_CreateContextGenerator);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var DomainCompose = function () {
	function DomainCompose(options) {
		_classCallCheck(this, DomainCompose);

		if (!options) {
			throw new Error("DomainCompose constructor options needs to be an object");
		}
		if (!options.domainServices) {
			throw new Error("DomainCompose constructor options needs to have property domainServices");
		}
		this.domainServices = options.domainServices;
		this.createContext = (0, _CreateContextGenerator2.default)({
			domainServices: options.domainServices
		});
	}

	_createClass(DomainCompose, [{
		key: "schema",
		get: function get() {
			var _this = this;

			var schemaObject = {
				query: {},
				mutation: {}
			};

			Object.keys(this.domainServices).map(function (p) {
				return _this.domainServices[p];
			}).forEach(function (s) {
				var schema = s.type.schema;
				schemaObject = {
					query: _extends({}, schemaObject.query, schema.query),
					mutation: _extends({}, schemaObject.mutation, schema.mutation)
				};
			});

			var finalSchemaObject = {};

			if (Object.keys(schemaObject.query).length > 0) {
				finalSchemaObject.query = new _graphql.GraphQLObjectType({
					name: "QueryType",
					fields: function fields() {
						return schemaObject.query;
					}
				});
			}

			if (Object.keys(schemaObject.mutation).length > 0) {
				finalSchemaObject.mutation = new _graphql.GraphQLObjectType({
					name: "MutationType",
					fields: function fields() {
						return schemaObject.mutation;
					}
				});
			}

			return new _graphql.GraphQLSchema(finalSchemaObject);
		}
	}]);

	return DomainCompose;
}();

exports.default = DomainCompose;