"use strict";

Object.defineProperty(exports, "__esModule", {
	value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _graphql = require("graphql");

var _protobufjs = require("protobufjs");

var _protobufjs2 = _interopRequireDefault(_protobufjs);

var _ConvertProtoType = require("./ConvertProtoType");

var _ConvertProtoType2 = _interopRequireDefault(_ConvertProtoType);

var _ListType = require("./ListType");

var _ListType2 = _interopRequireDefault(_ListType);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var DomainEntity = function () {
	function DomainEntity(options) {
		_classCallCheck(this, DomainEntity);

		if (!options) {
			throw new Error("DomainEntity options needs to be object");
		}
		if (!options.name) {
			throw new Error("DomainEntity options needs to have name property");
		}
		this.name = options.name;
		if (!options.fields) {
			throw new Error("DomainEntity " + this.name + " needs to have fields option");
		}
		this.fields = options.fields;
		if (typeof this.fields !== "function") {
			throw new Error("DomainEntity " + this.name + " fields option needs to be function");
		}

		// const fields = this.fields();
		// Object.keys(fields).forEach(fieldName => {
		// 	const field = fields[fieldName];
		// 	if (!field) {
		// 		throw new Error(this.name + " DomainEntity type has null field");
		// 	}
		// 	if (!field.type) {
		// 		throw new Error(this.name + " DomainEntity field " + fieldName + " type is null");
		// 	}
		// 	if (field.type instanceof ListType) {
		// 		if (!field.type.type) {
		// 			throw new Error(this.name + " DomainEntity field " + fieldName + " type is ListType but its type is null");
		// 		}
		// 	}
		// });
	}

	_createClass(DomainEntity, [{
		key: "schema",
		get: function get() {
			var _this = this;

			if (!this._schema) {
				var getFields = function getFields() {
					var fields = _this.fields();
					var newFields = {};
					Object.keys(fields).map(function (fieldName) {
						var field = fields[fieldName];
						if (!field) {
							throw new Error(_this.name + " DomainEntity type has null field");
						}
						if (!field.type) {
							throw new Error("DomainEntity " + _this.name + " field " + fieldName + " does not have valid type property");
						}
						if (field.type instanceof _ListType2.default) {
							if (!field.type.type) {
								throw new Error(_this.name + " DomainEntity field " + fieldName + " type is ListType but its type is null");
							}
						}
						var args = {};
						if (field.args) {
							Object.keys(field.args).forEach(function (argName) {
								var arg = field.args[argName];
								args[argName] = {
									type: arg.type.schema
								};
							});
						}
						newFields[fieldName] = {
							type: fields[fieldName].type.schema,
							args: args
						};
					});
					return newFields;
				};
				this._schema = new _graphql.GraphQLObjectType({
					name: this.name,
					fields: getFields
				});
			}
			return this._schema;
		}
	}]);

	return DomainEntity;
}();

exports.default = DomainEntity;