"use strict";

var _DomainEntity = require("./DomainEntity");

var _DomainEntity2 = _interopRequireDefault(_DomainEntity);

var _ListType = require("./ListType");

var _ListType2 = _interopRequireDefault(_ListType);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

describe("DomainEntity throw tests", function () {
	it("Should throw when options is null", function () {
		expect(function () {
			new _DomainEntity2.default();
		}).toThrow("DomainEntity options needs to be object");
	});
	it("Should throw when options name property is null", function () {
		expect(function () {
			new _DomainEntity2.default({});
		}).toThrow("DomainEntity options needs to have name property");
	});
	it("Should throw when options fields property is null", function () {
		expect(function () {
			new _DomainEntity2.default({
				name: "test"
			});
		}).toThrow("DomainEntity test needs to have fields option");
	});
	it("Should throw when options fields field type is null", function () {
		expect(function () {
			new _DomainEntity2.default({
				name: "test",
				fields: {
					name: {}
				}
			});
		}).toThrow("test DomainEntity field name type is null");
	});

	it("Should throw when options fields field ListType has null type", function () {
		expect(function () {
			new _DomainEntity2.default({
				name: "test",
				fields: {
					items: {
						type: new _ListType2.default()
					}
				}
			});
		}).toThrow("test DomainEntity field items type is ListType but its type is null");
	});
});

// describe("DomainEntity circular depency tests", () => {
// 	it("Should work with circular dependecies", () => {
// 	});
// });