"use strict";

Object.defineProperty(exports, "__esModule", {
	value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _protobufjs = require("protobufjs");

var _protobufjs2 = _interopRequireDefault(_protobufjs);

var _ConvertProtoType = require("./ConvertProtoType");

var _ConvertProtoType2 = _interopRequireDefault(_ConvertProtoType);

var _ListType = require("./ListType");

var _ListType2 = _interopRequireDefault(_ListType);

var _graphql = require("graphql");

var _stringhelpers = require("./stringhelpers");

var _method_types = require("./method_types");

var _method_types2 = _interopRequireDefault(_method_types);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var DomainService = function () {
	function DomainService(options) {
		var _this = this;

		_classCallCheck(this, DomainService);

		if (!options) {
			throw new Error("DomainService constructor options needs to be an object not null");
		}
		if (!options.name) {
			throw new Error("DomainService constructor options needs to have name property");
		}
		this.name = options.name;
		if (!options.services) {
			throw new Error(this.name + " DomainService constructor options needs to have services property");
		}
		this.services = options.services;
		if (!options.messages) {
			throw new Error(this.name + " DomainService constructor options needs to have messages property");
		}
		this.messages = options.messages;
		if (!options.methods) {
			throw new Error(this.name + " DomainService constructor options needs to have methods property");
		}
		this.methods = options.methods;

		Object.keys(this.methods).forEach(function (methodName) {
			var method = _this.methods[methodName];
			if (!method.type) {
				throw new Error(_this.name + " DomainService method " + methodName + " type property is null");
			}
			if (method.type instanceof _ListType2.default) {
				if (!method.type.type) {
					throw new Error(_this.name + " DomainService method " + methodName + " type ListType property type is null");
				}
			}
		});
	}

	_createClass(DomainService, [{
		key: "serviceMethods",
		get: function get() {}
	}, {
		key: "schema",
		get: function get() {
			var _this2 = this;

			if (!this._schema) {
				this._schema = {
					query: {},
					mutation: {}
				};

				Object.keys(this.methods).forEach(function (serviceMethodName) {
					var method = _this2.methods[serviceMethodName];

					if (method.name && !method.methodType) {
						throw new Error(_this2.name + " service method " + serviceMethodName + " needs to have methodType property");
					}

					if (!method.name && method.methodType) {
						throw new Error(_this2.name + " service method " + serviceMethodName + " needs to have name property");
					}

					var args = {};
					if (method.dataLoader) {
						args[method.dataLoader.name] = {
							type: _graphql.GraphQLID
						};
					} else {
						if (method.args) {
							args = {
								params: {
									type: new _graphql.GraphQLInputObjectType({
										name: (0, _stringhelpers.capitalizeFirstLetter)(method.name) + "Input",
										fields: function fields() {
											var a = {};
											Object.keys(method.args).forEach(function (argName) {
												a[argName] = {
													type: method.args[argName].type.schema
												};
											});
											return a;
										}
									})
								}
							};
						} else {
							throw new Error(_this2.name + " service method " + serviceMethodName + " needs to provide either args or dataLoader");
						}
					}
					var obj = {
						name: method.name,
						type: method.type.schema,
						args: args,
						resolve: function resolve(obj, props, context) {
							return context[_this2.name][serviceMethodName](props ? method.dataLoader ? props : props.params || {} : {});
						}
					};
					if (method.methodType === _method_types2.default.QUERY) {
						_this2._schema.query[method.name] = obj;
					} else if (method.methodType === _method_types2.default.MUTATION) {
						_this2._schema.mutation[method.name] = obj;
					}
				});
			}
			return this._schema;
		}
	}]);

	return DomainService;
}();

exports.default = DomainService;