"use strict";

var _DomainService = require("./DomainService");

var _DomainService2 = _interopRequireDefault(_DomainService);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

describe("Tests DomainService throws", function () {
	it("Should throw when options is null", function () {
		expect(function () {
			new _DomainService2.default();
		}).toThrow("DomainService constructor options needs to be an object not null");
	});
	it("Should throw when options name is null", function () {
		expect(function () {
			new _DomainService2.default({});
		}).toThrow("DomainService constructor options needs to have name property");
	});
	it("Should throw when options services is null", function () {
		expect(function () {
			new _DomainService2.default({
				name: "test"
			});
		}).toThrow("test DomainService constructor options needs to have services property");
	});
	it("Should throw when options messages is null", function () {
		expect(function () {
			new _DomainService2.default({
				name: "test",
				services: {}
			});
		}).toThrow("test DomainService constructor options needs to have messages property");
	});
	it("Should throw when options methods is null", function () {
		expect(function () {
			new _DomainService2.default({
				name: "test",
				services: {},
				messages: {}
			});
		}).toThrow("DomainService constructor options needs to have methods property");
	});
});