"use strict";

Object.defineProperty(exports, "__esModule", {
	value: true
});

var _stringhelpers = require("./stringhelpers");

var _DomainContextEntity = require("./DomainContextEntity");

var _DomainContextEntity2 = _interopRequireDefault(_DomainContextEntity);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

exports.default = function (_ref) {
	var messages = _ref.messages,
	    servicePackage = _ref.servicePackage,
	    serviceRoot = _ref.serviceRoot,
	    methodName = _ref.methodName,
	    client = _ref.client;

	var method = servicePackage.methods[methodName];
	var requestType = serviceRoot.lookupType(method.requestType);
	var responseType = serviceRoot.lookupType(method.responseType);
	return function (props) {
		return new Promise(function (resolve, reject) {
			var req = new messages[method.requestType]();
			Object.keys(requestType.fields).forEach(function (fieldName) {
				req["set" + (0, _stringhelpers.capitalizeOnlyFirstLetter)(fieldName)](props[fieldName]);
			});

			client[methodName](req, function (err, res) {
				if (err) {
					reject(err);
				} else {
					resolve((0, _DomainContextEntity2.default)({
						message: res,
						client: client
					}));
				}
			});
		});
	};
};